package com.jeeplus.test.workClientInfo.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jeeplus.test.workClientInfo.domain.WorkClientInfo;
import com.jeeplus.test.workClientInfo.domain.dto.PageInfoDto;
import com.jeeplus.test.workClientInfo.domain.dto.WorkClientInfosDto;
import com.jeeplus.test.workClientInfo.service.WorkClientService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;

@Slf4j
@Api(tags ="workClientInfo")
@RestController
@RequestMapping(value = "/workClientInfo/workClientInfo")
public class WorkClientController {

    @Resource
    private WorkClientService workClientService;

    /**
     * 客户信息列表
     */
    @ApiOperation(value = "客户信息列表")
    @PostMapping(value = "list")
    public Page<WorkClientInfo> list(@RequestBody PageInfoDto pageInfoDto) {
        return workClientService.list(pageInfoDto);
    }

    /**
     * 客户信息新增
     */
    @ApiOperation(value = "客户信息新增")
    @PostMapping(value = "add")
    public String add(@RequestBody WorkClientInfosDto workClientInfosDto) {
        return workClientService.add(workClientInfosDto);
    }

    /**
     * 客户信息删除
     */
    @ApiOperation(value = "客户信息删除")
    @GetMapping(value = "remove")
    public String remove(@RequestParam String id) {
        return workClientService.removeById(id);
    }

    /**
     * 客户信息查询
     */
    @ApiOperation(value = "客户信息查询")
    @GetMapping(value = "findById")
    public WorkClientInfosDto findById(@RequestParam String id) {
        return workClientService.findById(id);
    }

    /**
     * 客户信息更新
     */
    @ApiOperation(value = "客户信息更新")
    @PostMapping(value = "update")
    public String update(@RequestBody WorkClientInfosDto workClientInfosDto) {
        return workClientService.update(workClientInfosDto);
    }
}
